%module orngCRS
%{
#include "interface.h"
#include "svm.h"
%}

%typemap(python,ignore) struct LRInfo *OutValue {
    $1 = (struct LRInfo *)malloc(sizeof(struct LRInfo));
}

%typemap(python,ignore) struct CHInfo *OutValue {
    $1 = (struct CHInfo *)malloc(sizeof(struct CHInfo));
}

%typemap(python,ignore) struct CMInfo *OutValue {
    $1 = (struct CMInfo *)malloc(sizeof(struct CMInfo));
}

%typemap(python,ignore) struct CFInfo *OutValue {
    $1 = (struct CFInfo *)malloc(sizeof(struct CFInfo));
}

%typemap(python,argout) struct LRInfo *OutValue {
       int i,j;
       PyObject *o, *chisq, *devnce, *ndf, *beta, *se_beta, *fit, *covbeta, *deps; 
	   PyObject *error, *stdres, *ll, *kk;
//		printf("X+");
//		printf("lr:+1\n");
       o = PyTuple_New(10);
       chisq = PyFloat_FromDouble($1->chisq);
       devnce= PyFloat_FromDouble($1->devnce);
       ndf = PyInt_FromLong($1->ndf);
	   error = PyInt_FromLong($1->error);
       beta = PyList_New($1->k+1);
       for (i = 0; i <= $1->k; ++i) {
          ll = PyFloat_FromDouble($1->beta[i]);
		  PyList_SetItem(beta, i, ll);
       }
       se_beta = PyList_New($1->k+1);
       for (i = 0; i <= $1->k; ++i) {
          ll = PyFloat_FromDouble($1->se_beta[i]);
		  PyList_SetItem(se_beta, i, ll);
       }
       fit = PyList_New($1->nn);
       for (i = 1; i <= $1->nn; ++i) {
          ll = PyFloat_FromDouble($1->fit[i]);
		  PyList_SetItem(fit, i-1, ll);
       }
       stdres = PyList_New($1->nn);
       for (i = 1; i <= $1->nn; ++i) {
          ll = PyFloat_FromDouble($1->stdres[i]);
		  PyList_SetItem(stdres, i-1, ll);
       }
       covbeta = PyList_New($1->k+1);
       for (i = 0; i <= $1->k; ++i) {
	      kk =  PyList_New($1->k+1);
	      for(j = 0; j <= $1->k; ++j) {
			ll = PyFloat_FromDouble($1->cov_beta[i][j]);
			PyList_SetItem(kk, j, ll);
		  }
		  PyList_SetItem(covbeta, i, kk);
       }
       deps = PyList_New($1->k);
       for (i = 1; i <= $1->k; ++i) {
          ll = PyInt_FromLong($1->dependent[i]);
		  PyList_SetItem(deps, i-1, ll);
       }

       PyTuple_SetItem(o, 0, chisq);
       PyTuple_SetItem(o, 1, devnce);
       PyTuple_SetItem(o, 2, ndf);
       PyTuple_SetItem(o, 3, beta);
       PyTuple_SetItem(o, 4, se_beta);
	   PyTuple_SetItem(o, 5, fit);
       PyTuple_SetItem(o, 6, covbeta);
       PyTuple_SetItem(o, 7, stdres);
	   PyTuple_SetItem(o, 8, error);
	   PyTuple_SetItem(o, 9, deps);

	   LRInfoCleanup($1);

       if ((!$result) || ($result == Py_None)) {
	       $result = o;
       } else {
	       if (!PyList_Check($result)) {
		       PyObject *o2 = $result;
		       $result = PyList_New(0);
		       PyList_Append($result,o2);
		       Py_XDECREF(o2);
	       }
	       PyList_Append($result,o);
	       Py_XDECREF(o);
       }
//	   printf("lr:+2\n");
//		printf("-X");
}


%typemap(python,argout) struct CHInfo *OutValue {
       int i;
       PyObject *o, *ac, *n, *height, *order, *merging, *ll;

       o = PyTuple_New(5);
       n = PyInt_FromLong($1->n);
       ac = PyFloat_FromDouble($1->ac);
       merging = PyList_New(($1->n-1)*2);
       for (i = 0; i < ($1->n-1)*2; ++i) {
          ll = PyInt_FromLong($1->merging[i]);
		  PyList_SetItem(merging, i, ll);
       }
       order = PyList_New($1->n);
       for (i = 0; i < $1->n; ++i) {
          ll = PyInt_FromLong($1->order[i]);
		  PyList_SetItem(order, i, ll);
       }
       height = PyList_New($1->n-1);
       for (i = 0; i < $1->n-1; ++i) {
          ll = PyFloat_FromDouble($1->height[i+1]);
		  PyList_SetItem(height, i, ll);
       }
       PyTuple_SetItem(o, 0, n);
       PyTuple_SetItem(o, 1, merging);
       PyTuple_SetItem(o, 2, order);
       PyTuple_SetItem(o, 3, height);
       PyTuple_SetItem(o, 4, ac);

	   free($1->merging);
	   free($1->order);
	   free($1->height);
	   free($1);
       if ((!$result) || ($result == Py_None)) {
	       $result = o;
       } else {
	       if (!PyList_Check($result)) {
		       PyObject *o2 = $result;
		       $result = PyList_New(0);
		       PyList_Append($result,o2);
		       Py_XDECREF(o2);
	       }
	       PyList_Append($result,o);
	       Py_XDECREF(o);
       }
}

%typemap(python,argout) struct CMInfo *OutValue {
       int i;
       PyObject *o, *k, *cdisp, *disp, *n, *mapping, *medoids, *ll;

       o = PyTuple_New(6);
	   
       n = PyInt_FromLong($1->n);
       k = PyInt_FromLong($1->k);
       disp = PyFloat_FromDouble($1->disp);
	   
       mapping = PyList_New($1->n);
       for (i = 0; i < $1->n; ++i) {
          ll = PyInt_FromLong($1->mapping[i]);
		  PyList_SetItem(mapping, i, ll);
       }
       medoids = PyList_New($1->k);
       for (i = 0; i < $1->k; ++i) {
          ll = PyInt_FromLong($1->medoids[i]);
		  PyList_SetItem(medoids, i, ll);
       }
       cdisp = PyList_New($1->k);
       for (i = 0; i < $1->k; ++i) {
          ll = PyFloat_FromDouble($1->cdisp[i]);
		  PyList_SetItem(cdisp, i, ll);
       }
       PyTuple_SetItem(o, 0, n);
       PyTuple_SetItem(o, 1, k);
       PyTuple_SetItem(o, 2, mapping);
       PyTuple_SetItem(o, 3, medoids);
       PyTuple_SetItem(o, 4, cdisp);
       PyTuple_SetItem(o, 5, disp);
	   free($1->medoids);
	   free($1->cdisp);
	   free($1->mapping);
	   free($1);

       if ((!$result) || ($result == Py_None)) {
	       $result = o;
       } else {
	       if (!PyList_Check($result)) {
		       PyObject *o2 = $result;
		       $result = PyList_New(0);
		       PyList_Append($result,o2);
		       Py_XDECREF(o2);
	       }
	       PyList_Append($result,o);
	       Py_XDECREF(o);
       }
}


%typemap(python,argout) struct CFInfo *OutValue {
       int i,j,c;
       PyObject *o, *k, *cdisp, *disp, *n, *iterations, *value, *mapping, *membership, *ll, *kk;

       o = PyTuple_New(8);
	   
       n = PyInt_FromLong($1->n);
       k = PyInt_FromLong($1->k);
	   iterations = PyInt_FromLong($1->iterations);
	   disp = PyFloat_FromDouble($1->disp);
	   value = PyFloat_FromDouble($1->value);
	   
       mapping = PyList_New($1->n);
       for (i = 0; i < $1->n; ++i) {
          ll = PyInt_FromLong($1->mapping[i]);
		  PyList_SetItem(mapping, i, ll);
       }
       cdisp = PyList_New($1->k);
       for (i = 0; i < $1->k; ++i) {
          ll = PyFloat_FromDouble($1->cdisp[i]);
		  PyList_SetItem(cdisp, i, ll);
       }
       membership = PyList_New($1->k);
	   c = 0;
       for (i = 0; i < $1->k; ++i) {
		  kk = PyList_New($1->n);
		  for (j = 0; j < $1->n; ++j) {
			ll = PyFloat_FromDouble($1->membership[c++]);
			PyList_SetItem(kk, j, ll);
		  }
	   	  PyList_SetItem(membership, i, kk);
       }
       PyTuple_SetItem(o, 0, n);
       PyTuple_SetItem(o, 1, k);
       PyTuple_SetItem(o, 2, value);
       PyTuple_SetItem(o, 3, iterations);
       PyTuple_SetItem(o, 4, membership);
       PyTuple_SetItem(o, 5, mapping);
       PyTuple_SetItem(o, 6, cdisp);
       PyTuple_SetItem(o, 7, disp);
	   free($1->membership);
	   free($1->cdisp);
	   free($1->mapping);
	   free($1);

       if ((!$result) || ($result == Py_None)) {
	       $result = o;
       } else {
	       if (!PyList_Check($result)) {
		       PyObject *o2 = $result;
		       $result = PyList_New(0);
		       PyList_Append($result,o2);
		       Py_XDECREF(o2);
	       }
	       PyList_Append($result,o);
	       Py_XDECREF(o);
       }
}

// This tells SWIG to treat double * as a special case
%typemap(python,in) double * {
 /* Check if is a list */
 if (PyList_Check($input)) {
   int size = PyList_Size($input);
   int i = 0;
   $1 = (double *) malloc((1+size)*sizeof(double));
   for (i = 0; i < size; i++) {
     PyObject *o = PyList_GetItem($input,i);
     if (PyFloat_Check(o))
       $1[i] = PyFloat_AsDouble(PyList_GetItem($input,i));
     else if (PyInt_Check(o)) {
	   $1[i] = PyInt_AsLong(PyList_GetItem($input,i));
	 } else {
       PyErr_SetString(PyExc_TypeError,"list must contain floats");
       free($1);
       return NULL;
     }
   }
   $1[i] = 3.1459001;
 } else {
   PyErr_SetString(PyExc_TypeError,"not a list");
   return NULL;
 }
}

// This tells SWIG to treat int * as a special case
%typemap(python,in) int * {
 /* Check if is a list */
 if (PyList_Check($input)) {
   int size = PyList_Size($input);
   int i = 0;
   $1 = (int *) malloc((1+size)*sizeof(int));
   for (i = 0; i < size; i++) {
     PyObject *o = PyList_GetItem($input,i);
     if (PyInt_Check(o)) {
	   $1[i] = PyInt_AsLong(PyList_GetItem($input,i));
	 } else {
       PyErr_SetString(PyExc_TypeError,"list must contain floats");
       free($1);
       return NULL;
     }
   }
   $1[i] = -1;
 } else {
   PyErr_SetString(PyExc_TypeError,"not a list");
   return NULL;
 }
}


%typemap(python,in) struct SVMInput * {
 /* Check if is a list */
 if (PyList_Check($input)) {
   int i, j, k, size, msize;

   size = PyList_Size($input);
   msize = 0;

   $1 = (struct SVMInput *) malloc(sizeof(struct SVMInput));
   $1->data = NULL;
   $1->masking = NULL;
   $1->label = NULL;
   for (i = 0; i < size; i++) {
     PyObject *o = PyList_GetItem($input,i);
     if (PyList_Check(o)) {
		 int zsize = PyList_Size(o);
		 if ($1->data == NULL) {
			 msize = zsize;
			 $1->nn = size;
			 $1->k = msize-1;
			 $1->total = ($1->nn)*(msize-1+1); // size correction, last is class
			 $1->masking = (char **)malloc(sizeof(char *)*(size+1));
			 for (j = 0; j <= size; ++j) {
				$1->masking[j] = (char *)malloc(sizeof(char)*($1->k+1));
				for (k = 0; k <= $1->k; ++k) {
					$1->masking[j][k] = 0;
				}
			 }
			 $1->data = (double **)malloc(sizeof(double *)*(size+1));
			 for (j = 0; j <= size; ++j) {
				$1->data[j] = (double *)malloc(sizeof(double)*($1->k+1));
			 }
			 $1->label = (double *)malloc(sizeof(double)*($1->nn+1));
		 }
		 if (zsize == msize) {
			 // fetch the class (must be binary)
			 PyObject *p = PyList_GetItem(o,zsize-1);
			 if (p == NULL) {
				 PyErr_SetString(PyExc_TypeError,"cannot fetch example");
				 SVMcleanup($1);
				 return NULL;
			 }

			 if (PyInt_Check(p) || PyLong_Check(p)) {
				$1->label[i] = (double)PyInt_AsLong(p);
			 } else if(PyFloat_Check(p)) {
				$1->label[i] = PyFloat_AsDouble(p);
			 } else {
				 PyErr_SetString(PyExc_TypeError,"class not float or int");
				 SVMcleanup($1);
				 return NULL;
			 }
				
			 // fetch the attribute values
			 for (j = 0; j < zsize-1; ++j) {
			     PyObject *p = PyList_GetItem(o,j);

	 			 if(PyTuple_Check(p)) {
					 PyObject *ps = PyTuple_GetItem(p,1); // masking
					 if (PyInt_Check(ps) || PyLong_Check(ps)) {
						$1->masking[i][j] = (char)PyInt_AsLong(ps);
					 } else if(PyFloat_Check(ps)) {
						$1->masking[i][j] = (char)PyFloat_AsDouble(ps);
					 } else {
						 PyErr_SetString(PyExc_TypeError,"masking not 1 or 0");
						 SVMcleanup($1);
						 return NULL;
					 }
					 p = PyTuple_GetItem(p,0); // foist value
				 }
				 if (PyFloat_Check(p)) {
					// correct +1 because that array starts at 1
					$1->data[i][j] = PyFloat_AsDouble(p);
				 } else if (PyInt_Check(p)) {
					$1->data[i][j] = (double)PyInt_AsLong(p);
				 } else {
					 PyErr_SetString(PyExc_TypeError,"examples must contain doubles or ints. if masking, use tuples");
					 SVMcleanup($1);
					 return NULL;
				 }
			 }
		 } else {
			 PyErr_SetString(PyExc_TypeError,"examples must be of equal size");
			 SVMcleanup($1);
			 return NULL;
		 }
     } else {
       PyErr_SetString(PyExc_TypeError,"example table must contain examples as lists");
       SVMcleanup($1);
       return NULL;
     }
   }
 } else {
   PyErr_SetString(PyExc_TypeError,"not a list");
   return NULL;
 }
 //("svmi:done\n");
}

%typemap(python,in) struct SVMExample * {
 /* Check if is a list */
 if (PyList_Check($input)) {
   int j, msize;

   msize = PyList_Size($input);

   $1 = (struct SVMExample *)malloc(sizeof(struct SVMExample));
   $1->k = msize;
   $1->data    = (double *)malloc(sizeof(double)*msize);
   $1->masking = (char *)malloc(sizeof(char)*msize);

	// fetch the attribute values
	for (j = 0; j < msize; ++j) {
	 PyObject *p = PyList_GetItem($input,j);

	 if(PyTuple_Check(p)) {
		 PyObject *ps = PyTuple_GetItem(p,1); // masking
		 if (PyInt_Check(ps) || PyLong_Check(ps)) {
			$1->masking[j] = (char)PyInt_AsLong(ps);
		 } else if(PyFloat_Check(ps)) {
			$1->masking[j] = (char)PyFloat_AsDouble(ps);
		 } else {
			 PyErr_SetString(PyExc_TypeError,"masking not 1 or 0");
			 SVMexcleanup($1);
			 return NULL;
		 }
		 p = PyTuple_GetItem(p,0); // foist value
	 }
	 if (PyFloat_Check(p)) {
		$1->data[j] = PyFloat_AsDouble(p);
	 } else if (PyInt_Check(p)) {
		$1->data[j] = (double)PyInt_AsLong(p);
	 } else {
		 PyErr_SetString(PyExc_TypeError,"examples must contain doubles or ints. if masking, use tuples");
		 SVMexcleanup($1);
		 return NULL;
	 }
   }
 } else {
   PyErr_SetString(PyExc_TypeError,"not a list");
   return NULL;
 }
}

%typemap(python,in) struct LRInput * {
 /* Check if is a list */
// printf("A-");
 if (PyList_Check($input)) {
   int i, j, size, msize;

   size = PyList_Size($input);
   msize = 0;
	//printf("lr:-1\n");
   $1 = (struct LRInput *) malloc(sizeof(struct LRInput));
   $1->data = NULL;
   $1->success = NULL;
   for (i = 0; i < size; i++) {
     PyObject *o = PyList_GetItem($input,i);
     if (PyList_Check(o)) {
		 int zsize = PyList_Size(o);
		 if ($1->data == NULL) {
			 msize = zsize;
			 $1->nn = size;
			 $1->k = msize-1; // size correction, last is class
			 $1->data = (double **)malloc(sizeof(double *)*(size+1));
			 for (j = 0; j <= size; ++j) {
				$1->data[j] = (double *)malloc(sizeof(double)*($1->k+1));
			 }
			 $1->success = (double *)malloc(sizeof(double)*($1->nn+1));
			 $1->trials = (double *)malloc(sizeof(double)*($1->nn+1));
		 }
		 if (zsize == msize) {
			 // fetch the class (must be either binary or a tuple)
			 PyObject *p = PyList_GetItem(o,zsize-1);
			 if (p == NULL) {
				 PyErr_SetString(PyExc_TypeError,"cannot fetch example");
				 LRcleanup($1);
				 return NULL;
			 }
				
			 // the way of storing the class value is either simple scalar 
			 // probability, or tuple (probability, weight)

			 // set the default value for # trials
			 $1->trials[i+1] = 1.0;
	 		 if(PyTuple_Check(p)) {
				 PyObject *ps = PyTuple_GetItem(p,1); // get # trials
				 if (PyInt_Check(ps) || PyLong_Check(ps)) {
					$1->trials[i+1] = (double)PyInt_AsLong(ps);
				 } else if(PyFloat_Check(ps)) {
					$1->trials[i+1] = PyFloat_AsDouble(ps);
				 } else {
					 PyErr_SetString(PyExc_TypeError,"number of trials is not float or int");
					 LRcleanup($1);
					 return NULL;
				 }
				 p = PyTuple_GetItem(p,0); // foist a value for successes
			 } 
				
			 if (PyInt_Check(p) || PyLong_Check(p)) {
				$1->success[i+1] = $1->trials[i+1]*(double)PyInt_AsLong(p);
			 } else if(PyFloat_Check(p)) {
				$1->success[i+1] = $1->trials[i+1]*PyFloat_AsDouble(p);
			 } else {
				 PyErr_SetString(PyExc_TypeError,"experiment success is not float or int");
				 LRcleanup($1);
				 return NULL;
			 }
			 				
			 // fetch the attribute values
			 for (j = 0; j < zsize-1; ++j) {
			     PyObject *p = PyList_GetItem(o,j);
				 if (PyFloat_Check(p)) {
					// correct +1 because that array starts at 1
					$1->data[i+1][j+1] = PyFloat_AsDouble(p);
				 } else if (PyInt_Check(p)) {
					$1->data[i+1][j+1] = (double)PyInt_AsLong(p);
				 } else {
					 PyErr_SetString(PyExc_TypeError,"examples must contain doubles or ints");
					 LRcleanup($1);
					 return NULL;
				 }
			 }
		 } else {
			 PyErr_SetString(PyExc_TypeError,"examples must be of equal size");
			 LRcleanup($1);
			 return NULL;
		 }
     } else {
       PyErr_SetString(PyExc_TypeError,"example table must contain examples as lists");
       LRcleanup($1);
       return NULL;
     }
   }
 } else {
   PyErr_SetString(PyExc_TypeError,"not a list");
   return NULL;
 }
//  printf("-A");
 //printf("lr:-2\n");
}

%typemap(python,in) struct CInput * {
 /* Check if is a list */
 if (PyList_Check($input)) {
   int i, j, size, msize;

   size = PyList_Size($input);
   msize = 0;

   $1 = (struct CInput *) malloc(sizeof(struct CInput));
   $1->data = NULL;
   for (i = 0; i < size; i++) {
     PyObject *o = PyList_GetItem($input,i);
     if (PyList_Check(o)) {
		 int zsize = PyList_Size(o);
		 if ($1->data == NULL) {
			 msize = zsize;
			 $1->nn = size;
			 $1->jpp = msize;
			 $1->data = (double *)malloc(sizeof(double)*zsize*size);
		 }
		 if (zsize == msize) {
			 for (j = 0; j < zsize; ++j) {
			     PyObject *p = PyList_GetItem(o,j);
				 if (PyFloat_Check(p)) {
					$1->data[i+j*size] = PyFloat_AsDouble(p);
				 } else if (PyInt_Check(p)) {
					$1->data[i+j*size] = (double)PyInt_AsLong(p);
				 } else {
					 PyErr_SetString(PyExc_TypeError,"sublists must contain doubles");
					 if ($1->data != NULL)
						 free($1->data);
					 free($1);
					 return NULL;
				 }
			 }
		 } else {
			 PyErr_SetString(PyExc_TypeError,"sublists must be of equal size");
			 if ($1->data != NULL)
				 free($1->data);
			 free($1);
			 return NULL;
		 }
     } else {
       PyErr_SetString(PyExc_TypeError,"list must contain lists");
	   if ($1->data != NULL)
		   free($1->data);
       free($1);
       return NULL;
     }
   }
 } else {
   PyErr_SetString(PyExc_TypeError,"not a list");
   return NULL;
 }
}


%typemap(python,in) struct DInput * {
 /* Check if is a list */
 if (PyList_Check($input)) {
   int i, j, size, offset;

   size = PyList_Size($input);     /* the number of elements - 1 */

   $1 = (struct DInput *) malloc(sizeof(struct DInput));
   $1->nn = size+1;
   $1->data = (double *)malloc((1 + (size * (size + 1))/2)*sizeof(double));

   $1->data[0] = 0.0; // offset for pam and agnes
   //offset = (size * (size + 1))/2;
   offset = 1;
   for (i = 0; i < size; i++) {
     PyObject *o = PyList_GetItem($input,i);
     if (PyList_Check(o)) {
		 int zsize = PyList_Size(o); /* the line of a matrix */
		 if (zsize == i+1) {
			 for (j = 0; j < zsize; ++j) {
			     PyObject *p = PyList_GetItem(o,j);
				 if (PyFloat_Check(p)) {
					$1->data[offset++] = PyFloat_AsDouble(p);
				 } else if (PyInt_Check(p)) {
					$1->data[offset++] = (double)PyInt_AsLong(p);
				 } else {
					 PyErr_SetString(PyExc_TypeError,"sublists must contain doubles");
					 if ($1->data != NULL)
						 free($1->data);
					 free($1);
					 return NULL;
				 }
			 }
		 } else {
			 PyErr_SetString(PyExc_TypeError,"list must contain the bottom-triangular dissimilarity matrix");
			 if ($1->data != NULL)
				 free($1->data);
			 free($1);
			 return NULL;
		 }
     } else {
       PyErr_SetString(PyExc_TypeError,"list must contain lists");
	   if ($1->data != NULL)
		   free($1->data);
       free($1);
       return NULL;
     }
   }
   //assert(offset == 0);
 } else {
   PyErr_SetString(PyExc_TypeError,"not a list");
   return NULL;
 }
}


// This cleans up the double * array we malloc'd before the function call
%typemap(python,freearg) double * {
  free((double *) $1);
}

// This cleans up the double * array we malloc'd before the function call
%typemap(python,freearg) int * {
  free((int *) $1);
}

%typemap(python,freearg) struct LRInput * {
  int i;
  for (i = 0; i <= $1->nn; ++i)
	free((double*)$1->data[i]);
  free((double**) $1->data);
  free((double*) $1->success);
  free((double*) $1->trials);
  free((struct LRInput*) $1);
}

%typemap(python,freearg) struct SVMInput * {
  int i;
  //printf("svmc:1\n");
  for (i = 0; i <= $1->nn; ++i) {
	free((double*)$1->data[i]);
	free((char*)$1->masking[i]);
  }
  free((double**) $1->data);
  free((char**) $1->masking);
  free((double*) $1->label);
  free((struct SVMInput*) $1);
  //("svmc:2\n");
}

%typemap(python,freearg) struct SVMExample * {
  free((double*) $1->data);
  free((char*) $1->masking);
  free((struct SVMExample*) $1);
}

%typemap(python,freearg) struct CInput * {
  free((double*) $1->data);
  free((struct CInput*) $1);
}

%typemap(python,freearg) struct DInput * {
  free((double*) $1->data);
  free((struct DInput*) $1);
}


%typemap(python, in) struct svm_model * {
    PyObject *o, *t, *p, *zz, *uu;
	int m,l,i,j, elements;
	struct svm_node *x_space;
	struct svm_model *model;
	struct svm_parameter *param;


	o = $input;
	model = (struct svm_model *)malloc(sizeof(struct svm_model));
	param = &(model->param);
	model->label = NULL;
	model->nSV = NULL;

	if (!PyDict_Check(o)) {
       PyErr_SetString(PyExc_TypeError,"must be a dictionary");
       free(model);
       return NULL;
    }
	t = PyDict_GetItemString(o, "svm_type");
	if (!PyInt_Check(t)) {
       PyErr_SetString(PyExc_TypeError,"svm_type missing");
       free(model);
       return NULL;
    }
	param->svm_type = PyInt_AsLong(t);
	t = PyDict_GetItemString(o, "kernel_type");
	if (!PyInt_Check(t)) {
       PyErr_SetString(PyExc_TypeError,"kernel_type missing");
       free(model);
       return NULL;
    }
	param->kernel_type = PyInt_AsLong(t);
    	
	if(param->kernel_type == POLY) {
		t = PyDict_GetItemString(o, "degree");
		if (!PyFloat_Check(t)) {
		   PyErr_SetString(PyExc_TypeError,"degree missing");
		   free(model);
		   return NULL;
		}
		param->degree = PyFloat_AsDouble(t);
	}
	
	if(param->kernel_type == POLY || param->kernel_type == RBF || param->kernel_type == SIGMOID) {
		t = PyDict_GetItemString(o, "gamma");
		if (!PyFloat_Check(t)) {
		   PyErr_SetString(PyExc_TypeError,"gamma missing");
		   free(model);
		   return NULL;
		}
		param->gamma = PyFloat_AsDouble(t);
	}

	if(param->kernel_type == POLY || param->kernel_type == SIGMOID) {
		t = PyDict_GetItemString(o, "coef0");
		if (!PyFloat_Check(t)) {
		   PyErr_SetString(PyExc_TypeError,"coef0 missing");
		   free(model);
		   return NULL;
		}
		param->coef0 = PyFloat_AsDouble(t);
	}

	t = PyDict_GetItemString(o, "nr_class");
	if (!PyInt_Check(t)) {
	   PyErr_SetString(PyExc_TypeError,"nr_class missing");
	   free(model);
	   return NULL;
	}
	m = model->nr_class = PyInt_AsLong(t);
	t = PyDict_GetItemString(o, "total_sv");
	if (!PyInt_Check(t)) {
	   PyErr_SetString(PyExc_TypeError,"total_sv missing");
	   free(model);
	   return NULL;
	}
	l = model->l = PyInt_AsLong(t);


	t = PyDict_GetItemString(o, "rho");
	if (!PyList_Check(t)) {
	   PyErr_SetString(PyExc_TypeError,"rho missing");
	   free(model);
	   return NULL;
	}
	model->rho = (double *)malloc(sizeof(double)*m*(m-1)/2);
	for(i=0;i<m*(m-1)/2;i++) {
		p = PyList_GetItem(t, i);
		model->rho[i] = PyFloat_AsDouble(p);
	}

	t = PyDict_GetItemString(o, "label");
	if (t != NULL) {
		model->label = (int *)malloc(sizeof(int)*m);
		for(i=0;i<m;i++) {
			p = PyList_GetItem(t, i);
			model->label[i] = PyInt_AsLong(p);
		}
	}

	t = PyDict_GetItemString(o, "nr_sv");
	if (t != NULL) {
		model->nSV = (int *)malloc(sizeof(int)*m);
		for(i=0;i<m;i++) {
			p = PyList_GetItem(t, i);
			model->nSV[i] = PyInt_AsLong(p);
		}
	}

	t = PyDict_GetItemString(o, "elements");
	elements = PyInt_AsLong(t);
	
	model->sv_coef = (double **)malloc(sizeof(double *)*m);
	model->SV = (struct svm_node **)malloc(sizeof(struct svm_node **)*l);
	for(i=0;i<m;i++)
		model->sv_coef[i] = (double *)malloc(sizeof(double)*l);

	x_space = (struct svm_node *)malloc(sizeof(struct svm_node)*elements);

	p = PyDict_GetItemString(o, "SV");
	if (!PyList_Check(p) || PyList_Size(p)!=l) {
	   PyErr_SetString(PyExc_TypeError,"SV list missing");
	   free(model);
	   return NULL;
	}
	j = 0;
	for(i=0;i<l;i++)
	{
		int jj, kk;

		zz = PyList_GetItem(p,i);
		if (!PyList_Check(zz)) {
		   PyErr_SetString(PyExc_TypeError,"wrong SV vector (leak)"); return NULL;
		}

		t = PyList_GetItem(zz, 0); // sv_coef is first
		if (!PyList_Check(t) || PyList_Size(t)!= m-1 ) {
		   PyErr_SetString(PyExc_TypeError,"SV coef wrong (leak)"); return NULL;
		}

		for(jj=0;jj<m-1;jj++) {
			uu = PyList_GetItem(t, jj);
			if (!PyFloat_Check(uu)) {
				PyErr_SetString(PyExc_TypeError,"SV coef entry wrong (leak)"); return NULL;
			}
			model->sv_coef[jj][i] = PyFloat_AsDouble(uu);
		}

		model->SV[i] = &(x_space[j]);

		kk = PyList_Size(zz);

		for (jj = 1; jj < kk; ++jj) {
			t =PyList_GetItem(zz, jj);
			if (!PyTuple_Check(t)) {
				PyErr_SetString(PyExc_TypeError,"SV entry wrong (leak)"); return NULL;
			}
			
			uu = PyTuple_GetItem(t,0);
			x_space[j].index = PyInt_AsLong(uu);
			uu = PyTuple_GetItem(t,1);
			x_space[j].value = PyFloat_AsDouble(uu);

			++j;
		}
		x_space[j++].index = -1;
	}
	assert(j == elements);
	model->free_sv = 1;	// XXX
	$1 = model;
}

%typemap(python, out) struct svm_model * {
	const struct svm_parameter *param = &($1->param);
	const double **sv_coef;
	const struct svm_node **SV;
	struct svm_model *model = $1;
    int i, j, nr_class, l, elements;
    PyObject *o, *t, *p;

//    printf("svmo:1\n");
	o = PyDict_New();
    t = PyInt_FromLong(param->svm_type);
	PyDict_SetItemString(o, "svm_type", t); Py_XDECREF(t);
    t = PyInt_FromLong(param->kernel_type);
	PyDict_SetItemString(o, "kernel_type", t); Py_XDECREF(t);
    	
	if(param->kernel_type == POLY) {
		t =	PyFloat_FromDouble(param->degree);
		PyDict_SetItemString(o, "degree", t); Py_XDECREF(t);
	}

	if(param->kernel_type == POLY || param->kernel_type == RBF || param->kernel_type == SIGMOID) {
		t = PyFloat_FromDouble(param->gamma);
		PyDict_SetItemString(o, "gamma", t); Py_XDECREF(t);
	}

	if(param->kernel_type == POLY || param->kernel_type == SIGMOID) {
		t = PyFloat_FromDouble(param->coef0);
		PyDict_SetItemString(o, "coef0", t); Py_XDECREF(t);
	}

	nr_class = model->nr_class;
	l = model->l;

    t = PyInt_FromLong(nr_class);
	PyDict_SetItemString(o, "nr_class", t); Py_XDECREF(t);
    t = PyInt_FromLong(l);
	PyDict_SetItemString(o, "total_sv", t); Py_XDECREF(t);

	{
	   	t = PyList_New(nr_class*(nr_class-1)/2);
		for(i=0;i<nr_class*(nr_class-1)/2;i++) {
			PyList_SetItem(t, i, PyFloat_FromDouble($1->rho[i]));
		}
		PyDict_SetItemString(o, "rho", t); Py_XDECREF(t);
	}
	
	
	if($1->label) {
	   	t = PyList_New(nr_class);
		for(i=0;i<nr_class;i++) {
			PyList_SetItem(t, i, PyInt_FromLong($1->label[i]));
		}
		PyDict_SetItemString(o, "label", t); Py_XDECREF(t);
	}
	
	
	if($1->nSV) {
	   	t = PyList_New(nr_class);
		for(i=0;i<nr_class;i++) {
			PyList_SetItem(t, i, PyInt_FromLong($1->nSV[i]));
		}
		PyDict_SetItemString(o, "nr_sv", t); Py_XDECREF(t);
	}
	
	
	sv_coef = model->sv_coef;
	SV = model->SV;
	
	p = PyList_New(l);
	elements = l; // terminals
	for(i=0;i<l;i++)
	{
		const struct svm_node *pp;
		PyObject *zz;

	   	t = PyList_New(nr_class-1);
		for(j=0;j<nr_class-1;j++) {
			PyList_SetItem(t, j, PyFloat_FromDouble($1->sv_coef[j][i]));
		}

		// count attributes
		pp = SV[i];
		j = 1;
		while(pp->index != -1)
		{
			pp++; ++j;
		}

		// allocate
		zz = PyList_New(j);
		PyList_SetItem(zz, 0, t); // sv_coef is first

		pp = SV[i];
		j = 0;
		while(pp->index != -1)
		{
			t = PyTuple_New(2);
			PyTuple_SetItem(t,0,PyInt_FromLong(pp->index));
			PyTuple_SetItem(t,1,PyFloat_FromDouble(pp->value));
			pp++; ++j; ++elements;
			PyList_SetItem(zz,j,t);
		}

		PyList_SetItem(p,i,zz);
	}
	PyDict_SetItemString(o, "SV", p); Py_XDECREF(p);

//  printf("svmo:2\n");
    t = PyInt_FromLong(elements);
	PyDict_SetItemString(o, "elements", t); Py_XDECREF(t);
	svm_destroy_model($1);
    $result = o;
} 


void MCluster(struct CInput *in, long k, int metric, struct CMInfo *OutValue);
void HCluster(struct CInput *in, int metric, int method, struct CHInfo *OutValue);
void DMCluster(struct DInput *in, long k, struct CMInfo *OutValue);
void DHCluster(struct DInput *in, int method, struct CHInfo *OutValue);
void FCluster(struct CInput *in, long k, int metric, struct CFInfo *OutValue);
void DFCluster(struct DInput *in, long k, struct CFInfo *OutValue);
void LogReg(struct LRInput *input, struct LRInfo *OutValue);
void svm_destroy_model(struct svm_model *model);
psvm_model SVMClassifier(struct svm_model *InValue);
struct svm_model *SVMLearn(struct SVMInput *input, int svm_type, int kernel_type, int degree,
		 double gamma, double coef0, double nu, double cache_size, double C, 
		 double eps, double p, int shrinking, int nr_weight=0, double *weight=NULL, 
		 double *weight_label=NULL);
double SVMClassify(psvm_model model, struct SVMExample *input);
double SVMClassifyM(psvm_model model, struct SVMExample *input);
